require("src/MatchState")
require("src/MatchAIThinkState")
require("src/MatchCardMemory")


MatchCheckPlayerCardsState = class(MatchState)

function MatchCheckPlayerCardsState:ctor()
end


function MatchCheckPlayerCardsState:Execute()
    if(self.isLock == true) then
      return
    end
    self.isLock = true
    
    print("check player")
    print(PlayerFirstCards:getValue())
    print(PlayerSecondCards:getValue())
    if(PlayerFirstCards and PlayerSecondCards and PlayerFirstCards:getValue() ==
    PlayerSecondCards:getValue()) then
        print("have same value")
        MatchCardMemory:removeTwoCardsFromMemory(PlayerFirstCards,PlayerSecondCards)
        local seq = cc.Sequence:create(
                cc.CallFunc:create(self.runRemoveCardsAnimation),
                cc.DelayTime:create(0.5),
                cc.CallFunc:create(self.waitPlayerPlay));
        MatchLayer:runAction(seq);
        PlayerScore = PlayerScore + 2
    else
       print("have di value")
        MatchCardMemory:pushCardIntoMemory(PlayerFirstCards)
        MatchCardMemory:pushCardIntoMemory(PlayerSecondCards)
       self:changeTwoCardsToBack() 
    end  
end

function MatchCheckPlayerCardsState:runRemoveCardsAnimation()
    local visibleSize = cc.Director:getInstance():getVisibleSize()
    local VISIBLE_WIDTH = visibleSize.width

    PlayerFirstCards:setLocalZOrder(2);
    local moveAction = cc.MoveTo:create(MatchCardMoveOutTime,cc.p(VISIBLE_WIDTH - MatchCardMoveMarginLeft,216))
    local rotateAction = cc.RotateTo:create(MatchCardMoveOutTime,-20)
    local spawnAction = cc.Spawn:create(moveAction,rotateAction)
    PlayerFirstCards:runAction(spawnAction);

    PlayerSecondCards:setLocalZOrder(2);
    local spawnAction1 = spawnAction:clone();
    PlayerSecondCards:runAction(spawnAction1);

    MatchCardMemory:removeTwoCardsFromAllCards(PlayerFirstCards,
        PlayerSecondCards);
end

function MatchCheckPlayerCardsState:waitPlayerPlay()
   changeState(MatchWaitingPlayerState.new());
end

function MatchCheckPlayerCardsState:changeTwoCardsToBack()
   PlayerFirstCards:runFlipBackAction();
   PlayerSecondCards:runFlipBackAction();
    --等待片刻,变成AI回合
    local seq = cc.Sequence:create(cc.DelayTime:create(0.5),
        cc.CallFunc:create(self.waitAIPlay));
    MatchLayer:runAction(seq);
end

function MatchCheckPlayerCardsState:waitAIPlay()
    changeState(MatchAIThinkState.new())
end
