require("src/MatchState")
require("src/MatchGlobal")
require("src/MatchCheckAICardsState")

MatchClickSecondAICardState = class(MatchState)

function MatchClickSecondAICardState:ctor()
end


function MatchClickSecondAICardState:Execute()
    if(self.isLock == true) then
        return
    end
    self.isLock = true
    
    AISecondCard:runFlipAction()
    local seq = cc.Sequence:create(
        cc.DelayTime:create(0.8),
        cc.CallFunc:create(self.checkAICards))
    MatchLayer:runAction(seq)
    if(findCardsInMemory == false) then
        MatchCardMemory:pushCardIntoMemory(AISecondCard)
    end
end


function MatchClickSecondAICardState:checkAICards()
    changeState(MatchCheckAICardsState.new())
end