require("src/MatchState")
require("src/MatchGlobal")
require("src/MatchClickFirstAICardState")

MatchAIThinkState = class(MatchState)

function MatchAIThinkState:ctor()
    AIFirstCard = nil
    AISecondCard = nil
end

function MatchAIThinkState:Execute()
    if(self.isLock == true) then
        return
    end
    self.isLock = true
    
    local cardsInMemeory = MatchCardMemory:getTwoCardsFromMemory();
    if(#cardsInMemeory == 0) then
        local randomCards = MatchCardMemory:getTwoRandomCards();
        if(#randomCards > 0) then
            AIFirstCard = randomCards[1];
            AISecondCard = randomCards[2];
        else
            AIFirstCard = nil;
            AISecondCard = nil;
        end   
        findCardsInMemory = false;
    else
        AIFirstCard = cardsInMemeory[1];
        AISecondCard = cardsInMemeory[2];
        findCardsInMemory = true;
    end
    if(AIFirstCard and AISecondCard) then
        local seq = cc.Sequence:create(
            cc.DelayTime:create(0.8),
            cc.CallFunc:create(self.AIClickFirstCard));
        MatchLayer:runAction(seq);
    end
end


function MatchAIThinkState:AIClickFirstCard()
    changeState(MatchClickFirstAICardState.new());
end