

MatchCardMemory = {}
MatchCardMemory.memoryCardsContainer = {}
MatchCardMemory.allCards = {}
function MatchCardMemory:removeTwoCardsFromMemory(card1, card2)
    for i = 1, #(self.memoryCardsContainer) do
	   if self.memoryCardsContainer[i]:getTag() == card1:getTag() then
            table.remove(self.memoryCardsContainer, i)
            break
	   end   
	end
	
    for i = 1, #(self.memoryCardsContainer) do
        if self.memoryCardsContainer[i]:getTag() == card2:getTag() then
            table.remove(self.memoryCardsContainer, i)
            break
        end   
    end
end


function MatchCardMemory:pushCardIntoMemory(card)

    local alreadyExist = false
    for i = 1,#(self.memoryCardsContainer) do
        if self.memoryCardsContainer[i]:getTag() == card:getTag() then
            alreadyExist = true;
            break;
        end
    end
    if(alreadyExist == false) then
        table.insert(self.memoryCardsContainer,card)
    end

    
end


local function compare(c1, c2)
    return c1.value > c2.value
end

function MatchCardMemory:getTwoCardsFromMemory()
    local result = {};
    if(#(self.memoryCardsContainer) == 0) then
     return result;
    end 
    table.sort(self.memoryCardsContainer,compare)
    local firstIndex = 1;
    local secondIndex = 2;
    for firstIndex = 1, #(self.memoryCardsContainer) - 1 do
        secondIndex = firstIndex + 1;
        if(self.memoryCardsContainer[firstIndex]:getValue() ==
        self.memoryCardsContainer[secondIndex]:getValue()) then
           table.insert(result,self.memoryCardsContainer[firstIndex])
           table.insert(result,self.memoryCardsContainer[secondIndex])
           break
        end
    end
    return result;
end

local function randomCompare(v1, v2)
    return v1.random1 > v2.random1
end

function MatchCardMemory:getTwoRandomCards()
    local randomCards = {};
	for i = 1, #(self.allCards) do
        self.allCards[i].random1 = math.random()
    end
	
    for i = 1, #(self.allCards) do
       table.insert(randomCards,self.allCards[i])
    end
    table.sort(randomCards,randomCompare)
    return randomCards;
end

function MatchCardMemory:removeTwoCardsFromAllCards(card1, card2)
    for i = 1, #(self.allCards) do
        if self.allCards[i]:getTag() == card1:getTag() then
            table.remove(self.allCards, i)
            break
        end   
    end
    
    for i = 1, #(self.allCards) do
        if self.allCards[i]:getTag() == card2:getTag() then
            table.remove(self.allCards, i)
            break
        end   
    end
end