require("src/MatchState")
require("src/MatchGlobal")
require("src/MatchClickSecondAICardState")

MatchClickFirstAICardState = class(MatchState)

function MatchClickFirstAICardState:ctor()
end


function MatchClickFirstAICardState:Execute()
    if(self.isLock == true) then
        return
    end
    self.isLock = true
    AIFirstCard:runFlipAction();
    local seq = cc.Sequence:create(cc.DelayTime:create(0.5),
        cc.CallFunc:create(self.AIClickSecondCard))
    MatchLayer:runAction(seq);
    if(findCardsInMemory == false) then
        --把第一次点开的卡加入memory中,看是否有匹配的了,有的话改变第二张卡
        MatchCardMemory:pushCardIntoMemory(AIFirstCard);
        local newResult = MatchCardMemory:getTwoCardsFromMemory();
        if(#newResult > 0) then
            if(newResult[1]:getTag() == AIFirstCard:getTag()) then
                AISecondCard = newResult[2];
            else
                AISecondCard = newResult[1];
            end
        end
    end
end


function MatchClickFirstAICardState:AIClickSecondCard()
    changeState(MatchClickSecondAICardState.new());
end